/* FoundationAdditions.h created by lindberg on Mon 20-Dec-1999 */

#import <Foundation/NSArray.h>
#import <Foundation/NSString.h>
#import <Foundation/NSData.h>
#import <Foundation/NSFileManager.h>

/* Various Foundation methods for use by templates and/or EOGenerator */
@interface NSObject (ClassTestMethods)
- (BOOL)isString;
- (BOOL)isData;
- (BOOL)isInteger;
- (BOOL)isReal;
- (BOOL)isArray;
- (BOOL)isDictionary;
@end


@interface NSArray (EOGenerator)

- (NSArray *)reversedArray;

// Key-value additions (i.e. @reversedArray, @sortedNameArray, etc. keys)
- (id)computeReversedArrayForKey:(NSString *)key;
- (id)computeSortedNameArrayForKey:(NSString *)key;
- (id)computeSortedStringArrayForKey:(NSString *)key;

@end

@interface NSString (EOGenerator)

- (NSString *)initialCapitalString;
+ (id)stringWithCStringNoCopy:(char *)bytes length:(unsigned)length;
+ (id)stringWithCStringNoCopy:(char *)bytes length:(unsigned)length freeWhenDone:(BOOL)freeBuffer;

@end

@interface NSData (Base64Encoding)

- (NSString *)base64String;

@end

@interface NSFileManager (EOGenerator)

- (BOOL)directoryExistsAtPath:(NSString *)path;
- (BOOL)regularFileExistsAtPath:(NSString *)path;
- (NSString *)findFile:(NSString *)filename inSearchPath:(NSArray *)paths;
- (void)touchPath:(NSString *)filePath;

@end
